Attribute VB_Name = "modTaskCallBack"
Option Explicit

' Private member variables
Private objTask     As CAsynchTask
Private TimerID     As Long

' Win32 API Declares
Private Declare Function SetTimer Lib "user32" (ByVal hWnd As Long, _
                                        ByVal nIDEvent As Long, _
                                        ByVal uElapse As Long, _
                                        ByVal lpTimerProc As Long) _
                                        As Long

Private Declare Function KillTimer Lib "user32" (ByVal hWnd As Long, _
                                         ByVal nIDEvent As Long) _
                                         As Long

Sub RequestCallBack(obj As CAsynchTask)
    Set objTask = obj
    TimerID = SetTimer(0, 0, 1, AddressOf TimerProc)
End Sub

Public Sub TimerProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal idEvent As Long, ByVal lngSysTime As Long)
    KillTimer 0, TimerID
    TimerID = 0
    If Not (objTask Is Nothing) Then
        objTask.RunTask
    End If
    Set objTask = Nothing
End Sub
